function push(thearray,thevalue) {
	thearray[ thearray.length ] = thevalue;
}

function optionlabel(theoption) {
	if( theoption.label != null && theoption.label != "" ) {
		return theoption.label;
	}
	return theoption.innerHTML;
}

function optionvalue(theoption) {
	if( theoption.value != null && theoption.value != "" ) {
		return theoption.value;
	}
	return optionlabel(theoption);
}

function fieldvalue(thefield) {
	if( thefield.type == null ) {
		return "";
	}
	var v;
	switch( thefield.type.toLowerCase() ) {
		case "text":
		case "textarea":
		case "password":
		case "file":
		case "hidden":
		case "submit":
		case "reset":
		case "button":
		case "image":
			v = thefield.value; break;
		case "checkbox":
		case "radio":
			if( thefield.checked && thefield.value != null && thefield.value != "" ) {
				v = thefield.value;
			}
			else if( thefield.checked ) {
				v = "checked";
			}
			else {
				v = "";
			}
			break;
		case "select-one":
			v = thefield.selectedIndex == -1 ? "" : optionvalue(thefield[thefield.selectedIndex]); break;
		case "select-multiple":
			var data = new Array();
			for(var i=0; i<thefield.length; i++) {
				if( thefield[i].selected ) {
					push(data, optionvalue(thefield[i]));
				}
			}
			v = data.join(","); break;
		default:
			v = "unknown"; 
			break;
	}
	return v;
}

function arrayvalue(thefieldarray) {
	var data = new Array();
	if( thefieldarray.length == null ) {
		return data;
	}
	for(var i=0; i<thefieldarray.length; i++) {
		var thefield = thefieldarray[i];
		if( thefield.type != null ) {
			push(data, fieldvalue(thefield));
		}
	}
	return data;
}

function formvalue(thefield) {
	var v = "";
	if( thefield.type != null ) {
		v = fieldvalue(thefield);
	}
	else if( thefield.type == null && thefield.length != null && thefield.length > 0 ) {
		var data = arrayvalue(thefield);
		var first = false;
		for(var i=0; i<data.length; i++) {
			if(data[i] != "") {
				if( first == true ) {
					v += "," + data[i];
				}
				else {
					v += data[i];
					first = true;
				}
			}
		}
	}
	else {
		v = "unknown";
	}
	return v;
}

function validaterequired(thefield) {
	if( thefield.getAttribute("required") == "false" || thefield.getAttribute("required") == "no" ) {
		return true;
	}
	var v = fieldvalue(thefield);
	var i = thefield.getAttribute("ignore") == null ? "" : thefield.getAttribute("ignore");
	if( v != "" && v != i ) {
		return true;
	}
	if( thefield.getAttribute("required") == "group" ) {
		v = formvalue(thefield.form[thefield.name]);
		if( v != "" && v != i ) {
			return true;
		}
	}
	return false;
}

function check(theform,validators) {
	var errors = new Array();
	for(var i=0; i<theform.elements.length; i++) {
		var e = theform.elements[i];
		for(var type in validators) {
			if( e.getAttribute(type) != null && !validators[type](e) ) {
				push(errors, {target:e, error:type});
			}
		}
	}
	return errors;
}
