// returns true if the field contains only alphabetic characters (and _)
function validatealpha(thefield) {
	if( thefield.value.search(/^\w+$/) != -1 ) {
		return true;
	}
	return false;
}

// returns true if the field contains only alphanumeric characters (and _)
function validatealphanumeric(thefield) {
	if( thefield.value.search(/^[\w\d]+$/) != -1 ) {
		return true;
	}
	return false;
}

// returns true if the field contains an integer
function validateinteger(thefield) {
	if( thefield.value.search(/^\d+$/) != -1 ) {
		return true;
	}
	return false;
}

// returns true if the field contains an integer or floating point number
function validatefloat(thefield) {
	if( thefield.value.search(/^\d+\.?\d*$/) != -1 ) {
		return true;
	}
	if( thefield.value.search(/^\d*\.?\d+$/) != -1 ) {
		return true;
	}
	return false;
}

// returns true if the field contains a number which might be a credit card
// right now it's only a basic check for 15-16 digits and allowing spaces or hyphens
function validateccnumber(thefield) {
	if( thefield.value.search(/^[\d -]{15,16}$/) != -1 ) {
		return true;
	}
	return false;
}
